    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.scheme;
    022
    023import cascading.tuple.TupleEntry;
    024
    025/**
    026 * SinkCall provides access to the current {@link Scheme#sink(cascading.flow.FlowProcess, SinkCall)} invocation
    027 * arguments.
    028 * <p/>
    029 * Use the Context to store thread local values.
    030 *
    031 * @param <Context>
    032 * @param <Output>
    033 */
    034public interface SinkCall<Context, Output>
    035  {
    036  /**
    037   * Method getContext returns the context of this SinkCall object.
    038   *
    039   * @return the context (type C) of this SinkCall object.
    040   */
    041  Context getContext();
    042
    043  /**
    044   * Method setContext sets the context of this SinkCall object.
    045   *
    046   * @param context the context of this SinkCall object.
    047   */
    048  void setContext( Context context );
    049
    050  /**
    051   * Method getOutgoingEntry returns the final {@link TupleEntry} to be passed to the
    052   * {@link #getOutput()} output handler.
    053   * <p/>
    054   * That is, the result of calling getOutgoingEntry() should be passed directly to the
    055   * platform specific output handler returned by getOutput().
    056   * <p/>
    057   * Note the returned value from this method cannot be modified.
    058   *
    059   * @return TupleEntry
    060   */
    061  TupleEntry getOutgoingEntry();
    062
    063  Output getOutput();
    064  }